#include<iostream>

using namespace std;

int main(void)
{
    int brojac = 0,n;

    cin>>n;

    int niz[n],niz2[n];

    for(int i=0;i<n;++i)
        cin>>niz[i]>>niz2[i];

    for(int i=0;i<n-1;++i){
        for(int j=i+1;j<n;++j)
        {
            if(niz[i] == niz[j]){
                brojac++;

                 break;
            }
             if(niz2[i] == niz2[j]){
                brojac++;
                 break;
            }

        }
    }
    if(n<=3 || brojac==n-1)
    cout<<brojac;
    else cout<<brojac-1;



    return 0;
}